import 'package:flutter/material.dart';
import 'package:flutter_amap_location_plugin/flutter_amap_location_plugin.dart';

/// @desc 持续定位
/// @time 2019-05-20 14:45
/// @author chenyun
class ListenerLocation extends StatefulWidget {
  @override
  _ListenerLocationState createState() => _ListenerLocationState();
}

class _ListenerLocationState extends State<ListenerLocation> {
  String location;

  @override
  Widget build(BuildContext context) {
    return new Scaffold(
        appBar: new AppBar(
          title: new Text('监听定位改变'),
        ),
        body: new Center(
          child: new Text(location),
        ));
  }

  void _checkPersmission() async {
//    bool hasPermission =
//    await SimplePermissions.checkPermission(Permission.WhenInUseLocation);
//    if (!hasPermission) {
//      PermissionStatus requestPermissionResult =
//      await SimplePermissions.requestPermission(
//          Permission.WhenInUseLocation);
//      if (requestPermissionResult != PermissionStatus.authorized) {
//        Alert.alert(context, title: "申请定位权限失败");
//        return;
//      }
//    }
    FlutterAmapLocationPlugin.onLocationUpdate.listen((AMapLocation loc) {
      if (!mounted) return;
      setState(() {
        location = getLocationStr(loc);
      });
    });

    FlutterAmapLocationPlugin.startLocation();
  }

  @override
  void initState() {
    location = getLocationStr(null);
    _checkPersmission();

    super.initState();
  }

  @override
  void dispose() {
    //注意这里停止监听
    FlutterAmapLocationPlugin.stopLocation();
    super.dispose();
  }

  String getLocationStr(AMapLocation loc) {
    if (loc == null) {
      return "正在定位";
    }

    if (loc.isSuccess()) {
      if (loc.hasAddress()) {
        return "定位成功: \n时间${loc.timestamp}\n经纬度:${loc.latitude} ${loc.longitude}\n 地址:${loc.address} 城市:${loc.city} 省:${loc.province}";
      } else {
        return "定位成功: \n时间${loc.timestamp}\n经纬度:${loc.latitude} ${loc.longitude}\n ";
      }
    } else {
      return "定位失败: \n错误:{code=${loc.errorCode},description=${loc.description}";
    }
  }
}
